package org.dromara.web.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.web.domain.ProductStock;
import org.dromara.web.domain.bo.ProductStockBo;
import org.dromara.web.domain.vo.ProductStockVo;
import org.dromara.web.mapper.ProductStockMapper;
import org.dromara.web.service.IProductStockService;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 产品库存Service业务层处理
 *
 * @author Lion Li
 * @date 2025-08-20
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class ProductStockServiceImpl implements IProductStockService {

    private final ProductStockMapper baseMapper;

    /**
     * 查询产品库存
     *
     * @param id 主键
     * @return 产品库存
     */
    @Override
    public ProductStockVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询产品库存列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 产品库存分页列表
     */
    @Override
    public TableDataInfo<ProductStockVo> queryPageList(ProductStockBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<ProductStock> lqw = buildQueryWrapper(bo);
        Page<ProductStockVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的产品库存列表
     *
     * @param bo 查询条件
     * @return 产品库存列表
     */
    @Override
    public List<ProductStockVo> queryList(ProductStockBo bo) {
        LambdaQueryWrapper<ProductStock> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<ProductStock> buildQueryWrapper(ProductStockBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<ProductStock> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(ProductStock::getId);
        lqw.eq(bo.getLocationId() != null, ProductStock::getLocationId, bo.getLocationId());
        lqw.eq(bo.getCategoryId() != null, ProductStock::getCategoryId, bo.getCategoryId());
        if (bo.getSearchValue() != null) {
            lqw.and(wrapper -> wrapper.eq(ProductStock::getProductNo, bo.getSearchValue()).or().eq(ProductStock::getProductName, bo.getSearchValue()));
        }
        lqw.eq(StringUtils.isNotBlank(bo.getStatus()), ProductStock::getStatus, bo.getStatus());
        return lqw;
    }

    /**
     * 新增产品库存
     *
     * @param bo 产品库存
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(ProductStockBo bo) {
        ProductStock add = MapstructUtils.convert(bo, ProductStock.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改产品库存
     *
     * @param bo 产品库存
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(ProductStockBo bo) {
        ProductStock update = MapstructUtils.convert(bo, ProductStock.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(ProductStock entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除产品库存信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
